<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>URI Routing</h1>

		<p>Usually there is a one to one relationship betweenn the URL segments and controllers/methods. The segments
		in a URI normally follow the pattern below.</p>

		<div class="example">
			www.your-domain.com/<b>class</b>/<b>method</b>/<b>id</b>/
		</div>

		<p>However you may wish to remap this relationship so a different controller/method is called instead of the
		one specified in the URL.  For example if you want your URLs to have the following prototype.</p>

		<div class="example">
			www.your-domain.com/post/1/<br />
			www.your-domain.com/post/2/<br />
			www.your-domain.com/post/3/<br />
			www.your-domain.com/post/4/
		</div>

		<p>Usually the second URI segment is reserved for the method name, but in the above the second URI segment
		is the post ID.  CarbonPHP allows you to remap the URI handler.</p>
	</div>

	<div class="content">
		<h1>Setting Your Own Routes</h1>

		<p>Routing rules are declared in the <b>application/config/routing.php</b> configuration file.  Inside this
		configuration file you will see an array called <b>$routing</b> which permits you to specify you own rules
		for routing.  These rules can be specified using wildcards or regular expressions.</p>
	</div>

	<div class="content">
		<h1>Wildcard Routing Rules</h1>

		<p>Usually a wildcard rule would look something like the following.</p>

		<div class="example">
			$routing['post/:num'] = 'blog/post';
		</div>

		<p>In a routing rule, the array key contains the URI to be matched, while the array value contains the
		destination it should be remapped to.  In the above example, if the word <b>post</b> is found in the first
		segment of the URI, and a number is found in the second segment, the controller <b>blog</b> and method
		<b>post</b> are used instead.</p>

		<p>There are can match literal values or use two wildcard types.</p>

		<ul>
			<li><b>:num</b> - this will match a segment containing only numbers.</li>
			<li><b>:any</b> - this will match a segment containing any character.</li>
		</ul>

		<p>Some examples of routing are shown below.</p>

		<div class="example">
			$routing['journals'] = 'blogs';
		</div>

		<p>In the above example any URL containing the word <b>journals</b> in the first segment, it will be remapped
		to the <b>blogs</b> controller.</p>

		<div class="example">
			$routing['blog/john'] = 'blogs/user/1';
		</div>

		<p>In the above example any URL containing the word <b>blog</b> and <b>john</b> in the URL segements it will
		be remapped to the <b>blogs</b> controller, the <b>users</b> methods, and with the third segment being the
		ID.</p>

		<div class="example">
			$routing['product/:any'] = 'catalog/products';
		</div>

		<p>Any URL with <b>product</b> in the first segment, and anything is in the second segment, it will be
		remapped to the <b>catalog</b> controller and the <b>products</b> method.</p>

		<p><i>Note</i>: remember to not use leading and trailing slashes.</p>
	</div>

	<div class="content">
		<h1>Regular Expression Routing Rules</h1>

		<p>If you prefer you can use regular expressions in the routing rules you define.  Any regular expression that
		is valid is allowed.  <i>Note</i>: if you use back-references you have to use the dollar syntax, instead
		of the double backslash syntax.</p>

		<p>A typical regular expression syntax might look like the following.</p>

		<div class="example">
			$routing['products/([a-z]+)/(\d+)'] = '$1/id_$2';
		</div>

		<p>In the above example, any URI similar to <b>products/shirts/12/</b> would instead call the <b>shirts</b>,
		and the <b>id_12</b> method.  You can also mix and match wildcards with regular expressions.</p>
	</div>

	<div class="content">
		<h1>Reserved Routes</h1>

		<p>There are two reserved routes in CarbonPHP.  These are the <b>default_controller</b> and
		<b>scaffolding_trigger</b> routes.</p>

		<div class="example">
			$routing['default_controller'] = 'welcome';
		</div>

		<p>The above route specifies which controller class that CarbonPHP should load if no first segment is
		specified in the URI.  You should always declare a default controller, otherwise people will encounter
		a 404 page by default.</p>

		<div class="example">
			$routing['scaffolding_trigger'] = 'secret_word';
		</div>

		<p>This route lets you choose a secret word that when specified in the URL will trigger the CarbonPHP
		scaffolding.</p>

		<p><i>Note</i>: the reserved routes must <b>always</b> appear before any custom routing rules.</p>
	</div>
</body>

</html>
